<?php

/** Copyright 2009 Tactical FLEX
 *
 * Aanval 5
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

function storeRuleData($ruleVersion, $policy, $ruleFile, $array) {

	$numTotal = 0;

	if (!$array || empty($array)) {
	
		return;
	}
	
	$snortRuleFile = "../../smt/snortRules/data/snortRules-" . $policy . ".dat";

	if (file_exists($snortRuleFile)) {
	
		$tmp = file($snortRuleFile);
		
		$policyName = trim($tmp[1]);
		$ruleVersion = trim($tmp[2]);

		if ($tmp[4]) {
			$dataArray = explode("||", trim($tmp[4]));
			
			foreach ($dataArray as $categoryList) {
			
				$tmp = explode(":", $categoryList);
			
				$category = $tmp[0];
				$signatureList = $tmp[1];
	
				$buildArray[$category] = $signatureList;
			
			}
		}

		$tmpList = implode(",", $array);
		
		$buildArray[$ruleFile] .= "," . $tmpList;
		
		// Process main build array back into write data
		foreach ($buildArray as $cat => $list) {

			if (substr($list, 0, 1) == ",") $list = substr($list, 1);

			$tmpArray = explode(",", trim($list));
			$newArray = array_unique($tmpArray);

			$list = implode(",", $newArray);

			$writeData .= "||$cat:" . $list;

			$numTotal += count($newArray);
		
		}

		if (substr($writeData, 0, 2) == "||") $writeData = substr($writeData, 2);

		$fp = fopen($snortRuleFile, "w");
		fwrite($fp, time() . "\n" . $policyName . "\n" . $ruleVersion . "\n" . $numTotal . "\n" . $writeData);
		fclose($fp);
	
	} else {

		if ($fp = fopen("$snortRuleFile", "w")) {

			$numTotal = count($array);

			$outData = $ruleFile . ":" . implode(",", $array);
			
			fwrite($fp, time() . "\n" . "Not Yet Named" . "\n" . $ruleVersion . "\n" . $numTotal . "\n" . $outData);
			fclose($fp);
			
		}
	
	}

}

function deleteRuleData($ruleVersion, $policy, $ruleFile, $array) {

	$numTotal = 0;

	if (!$array || empty($array)) {
	
		return;
	}
	
	$snortRuleFile = "../../smt/snortRules/data/snortRules-" . $policy . ".dat";

	if (file_exists($snortRuleFile)) {
	
		$tmp = file($snortRuleFile);
		
		$policyName = trim($tmp[1]);
		$ruleVersion = trim($tmp[2]);

		if ($tmp[4]) {

			$dataArray = explode("||", trim($tmp[4]));
			
			foreach ($dataArray as $categoryList) {
			
				$tmp = explode(":", $categoryList);
			
				$category = $tmp[0];
				$signatureList = $tmp[1];
	
				$buildArray[$category] = $signatureList;
			
			}
	
			// Process main build array back into write data
			foreach ($buildArray as $cat => $list) {
	
				if (substr($list, 0, 1) == ",") $list = substr($list, 1);
	
				$tmpArray = explode(",", trim($list));
	
				$newArray = array_diff($tmpArray, $array);
				$newArray = array_unique($newArray);
	
				if (count($newArray) > 0) {
	
					$list = implode(",", $newArray);
				
					$writeData .= "||$cat:" . $list;
		
					$numTotal += count($newArray);
				}
			
			}
			
			if (substr($writeData, 0, 2) == "||") $writeData = substr($writeData, 2);
			
			$fp = fopen($snortRuleFile, "w");
			fwrite($fp, time() . "\n" . $policyName . "\n" . $ruleVersion . "\n" . $numTotal . "\n" . $writeData);
			fclose($fp);
		}
	}
	
}

?>