<?php

/** Copyright 2009 Tactical FLEX
 *
 * Aanval 5
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function prv_frequentOffenders() {
	global $idsDB;
	
	$num = sanitize("num");
	if (!$num || $num == 0) $num = 100;

	$xml = "<document>\n";

	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$sensorArray = explode(",", login("sensors"));
		
		foreach ($sensorArray as $sensor) {
		
			$tmpArray[] = "evt.customGrouping LIKE '%" . trim($sensor) . "%'";
		
		}
		
		$sensorString = implode(" or ", $tmpArray);

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.sip FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where $sensorString group by evt.sip order by cnt desc limit $num");

		$totalEvents = getTotalEventsByCustomGrouping($sensorString);
	
	} else {

		// Standard Results

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.sip FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where mas.sensorID in (" . login("sensors") . ") group by evt.sip order by cnt desc limit $num");
	
		$totalEvents = getTotalEventsBySensors(login("sensors"));
	
	}

	while ($row = mysql_fetch_array($idsQueryA)) {
	
		$xml .= "\t<node>\n";
		
		if (!$host) $host = longToIP($row[1]);
		
		$perc = number_format(abs($row[0]/$totalEvents*100), 2);

		$xml .= "\t\t<host>$host</host>\n";
		$xml .= "\t\t<ip>" . longToIP($row[1]) . "</ip>\n";
		$xml .= "\t\t<count>" . $row[0] . "</count>\n";
		$xml .= "\t\t<percent>$perc</percent>\n";

		unset($host, $perc);

		$xml .= "\t</node>\n";
	
	}

	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
}

function prv_infrequentOffenders() {
	global $idsDB;
	
	$num = sanitize("num");
	if (!$num || $num == 0) $num = 100;

	$xml = "<document>\n";

	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$sensorArray = explode(",", login("sensors"));
		
		foreach ($sensorArray as $sensor) {
		
			$tmpArray[] = "evt.customGrouping LIKE '%" . trim($sensor) . "%'";
		
		}
		
		$sensorString = implode(" or ", $tmpArray);

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.sip FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where $sensorString group by evt.sip order by cnt asc limit $num");

		$totalEvents = getTotalEventsByCustomGrouping($sensorString);
	
	} else {

		// Standard Results

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.sip FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where mas.sensorID in (" . login("sensors") . ") group by evt.sip order by cnt asc limit $num");
		
		$totalEvents = getTotalEventsBySensors(login("sensors"));
		
	}
	
	while ($row = mysql_fetch_array($idsQueryA)) {
	
		$xml .= "\t<node>\n";
		
		if (!$host) $host = longToIP($row[1]);
		
		$perc = number_format(abs($row[0]/$totalEvents*100), 2);

		$xml .= "\t\t<host>$host</host>\n";
		$xml .= "\t\t<ip>" . longToIP($row[1]) . "</ip>\n";
		$xml .= "\t\t<count>" . $row[0] . "</count>\n";
		$xml .= "\t\t<percent>$perc</percent>\n";

		unset($host, $perc);

		$xml .= "\t</node>\n";
	
	}

	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
}

function prv_frequentTargets() {
	global $idsDB;
	
	$num = sanitize("num");
	if (!$num || $num == 0) $num = 100;

	$xml = "<document>\n";

	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$sensorArray = explode(",", login("sensors"));
		
		foreach ($sensorArray as $sensor) {
		
			$tmpArray[] = "evt.customGrouping LIKE '%" . trim($sensor) . "%'";
		
		}
		
		$sensorString = implode(" or ", $tmpArray);

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.dip FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where $sensorString group by evt.dip order by cnt desc limit $num");

		$totalEvents = getTotalEventsByCustomGrouping($sensorString);
	
	} else {

		// Standard Results

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.dip FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where mas.sensorID in (" . login("sensors") . ") group by evt.dip order by cnt desc limit $num");
	
		$totalEvents = getTotalEventsBySensors(login("sensors"));
	
	}

	while ($row = mysql_fetch_array($idsQueryA)) {
	
		$xml .= "\t<node>\n";
		
		if (!$host) $host = longToIP($row[1]);
		
		$perc = number_format(abs($row[0]/$totalEvents*100), 2);

		$xml .= "\t\t<host>$host</host>\n";
		$xml .= "\t\t<ip>" . longToIP($row[1]) . "</ip>\n";
		$xml .= "\t\t<count>" . $row[0] . "</count>\n";
		$xml .= "\t\t<percent>$perc</percent>\n";

		unset($host, $perc);

		$xml .= "\t</node>\n";
	
	}

	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
}

function prv_infrequentTargets() {
	global $idsDB;
	
	$num = sanitize("num");
	if (!$num || $num == 0) $num = 100;

	$xml = "<document>\n";

	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$sensorArray = explode(",", login("sensors"));
		
		foreach ($sensorArray as $sensor) {
		
			$tmpArray[] = "evt.customGrouping LIKE '%" . trim($sensor) . "%'";
		
		}
		
		$sensorString = implode(" or ", $tmpArray);

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.dip FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where $sensorString group by evt.dip order by cnt asc limit $num");

		$totalEvents = getTotalEventsByCustomGrouping($sensorString);
	
	} else {

		// Standard Results

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.dip FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where mas.sensorID in (" . login("sensors") . ") group by evt.dip order by cnt asc limit $num");
		
		$totalEvents = getTotalEventsBySensors(login("sensors"));
		
	}
	
	while ($row = mysql_fetch_array($idsQueryA)) {
	
		$xml .= "\t<node>\n";
		
		if (!$host) $host = longToIP($row[1]);
		
		$perc = number_format(abs($row[0]/$totalEvents*100), 2);

		$xml .= "\t\t<host>$host</host>\n";
		$xml .= "\t\t<ip>" . longToIP($row[1]) . "</ip>\n";
		$xml .= "\t\t<count>" . $row[0] . "</count>\n";
		$xml .= "\t\t<percent>$perc</percent>\n";

		unset($host, $perc);

		$xml .= "\t</node>\n";
	
	}

	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
}

function prv_frequentEvents() {
	global $idsDB;
	
	$num = sanitize("num");
	if (!$num || $num == 0) $num = 100;

	$xml = "<document>\n";

	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$sensorArray = explode(",", login("sensors"));
		
		foreach ($sensorArray as $sensor) {
		
			$tmpArray[] = "evt.customGrouping LIKE '%" . trim($sensor) . "%'";
		
		}
		
		$sensorString = implode(" or ", $tmpArray);

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.signatureName, evt.signature FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where $sensorString group by evt.signatureName order by cnt desc limit $num");

		$totalEvents = getTotalEventsByCustomGrouping($sensorString);
	
	} else {

		// Standard Results

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.signatureName, evt.signature FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where mas.sensorID in (" . login("sensors") . ") group by evt.signatureName order by cnt desc limit $num");
		
		$totalEvents = getTotalEventsBySensors(login("sensors"));
		
	}

	while ($row = mysql_fetch_array($idsQueryA)) {
	
		$xml .= "\t<node>\n";
		
		$perc = number_format(abs($row[0]/$totalEvents*100), 2);

		$xml .= "\t\t<sigid>" . $row[2] . "</sigid>\n";
		$xml .= "\t\t<signame>" . htmlentities($row[1]) . "</signame>\n";
		$xml .= "\t\t<count>" . $row[0] . "</count>\n";
		$xml .= "\t\t<percent>$perc</percent>\n";

		unset($sigID, $sigName, $perc);

		$xml .= "\t</node>\n";
	
	}


	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;	
}

function prv_infrequentEvents() {
	global $idsDB;
	
	$num = sanitize("num");
	if (!$num || $num == 0) $num = 100;

	$xml = "<document>\n";

	if (ops("site_custom_snortGroup") == 1) {

		// Custom Grouping Results
	
		$sensorArray = explode(",", login("sensors"));
		
		foreach ($sensorArray as $sensor) {
		
			$tmpArray[] = "evt.customGrouping LIKE '%" . trim($sensor) . "%'";
		
		}
		
		$sensorString = implode(" or ", $tmpArray);

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.signatureName, evt.signature FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where $sensorString group by evt.signatureName order by cnt asc limit $num");

		$totalEvents = getTotalEventsByCustomGrouping($sensorString);
	
	} else {

		// Standard Results

		$idsQueryA = $idsDB->query("SELECT count(mas.id) as cnt, evt.signatureName, evt.signature FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas LEFT JOIN idsDataStore_" . login("activeSearchStore") . "_Events as evt on (mas.id = evt.id) where mas.sensorID in (" . login("sensors") . ") group by evt.signatureName order by cnt asc limit $num");
		
		$totalEvents = getTotalEventsBySensors(login("sensors"));
		
	}

	while ($row = mysql_fetch_array($idsQueryA)) {
	
		$xml .= "\t<node>\n";
		
		$perc = number_format(abs($row[0]/$totalEvents*100), 2);

		$xml .= "\t\t<sigid>" . $row[2] . "</sigid>\n";
		$xml .= "\t\t<signame>" . htmlentities($row[1]) . "</signame>\n";
		$xml .= "\t\t<count>" . $row[0] . "</count>\n";
		$xml .= "\t\t<percent>$perc</percent>\n";

		unset($sigID, $sigName, $perc);

		$xml .= "\t</node>\n";
	
	}


	$xml .= "\t<totalevents>" . $totalEvents . "</totalevents>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
	
}

function getTotalEventsBySensors($sensorList) {
	global $idsDB;

	$idsQueryA = $idsDB->query("SELECT count(*) FROM idsDataStore_" . login("activeSearchStore") . "_Master as mas where mas.sensorID in ('$sensorList')");
	while (list($res) = mysql_fetch_row($idsQueryA)) {
		$eventTotal = $res;
	}

	return $eventTotal;

}	

function getTotalEventsByCustomGrouping($sensorString) {
	global $idsDB;

	$idsQueryA = $idsDB->query("SELECT count(*) FROM idsDataStore_" . login("activeSearchStore") . "_Events as evt where $sensorString");
	while (list($res) = mysql_fetch_row($idsQueryA)) {
		$eventTotal = $res;
	}

	return $eventTotal;

}

?>