<?php

/** Copyright 2009 Tactical FLEX
 *
 * Aanval 5
 *
 * This program is owned and licensed by Tactical FLEX; it may be
 * redistributed only in its original configuration as originally
 * installed and available by Tactical FLEX and / or Aanval.
 *
 * To license and / or include this product in other forms or
 * applications, express prior written authorization must be
 * obtained by contract from authorized Tactical FLEX or Aanval agents.
 *
 * Tactical FLEX and Aanval may not be held liable nor responsible
 * for any and all issues arising from the use of, damages caused by, or 
 * conclusions drawn from the use of this product.
 *
 */

include "initialize.php";

function pub_userAuthenticate() {
	global $login, $idsDB;
	
	// TF
	
	$xml = "<document>\n";
	
	// Session
	$xml .= "\t<session>\n";
	
	if (login("login") == true) {
	
		$xml .= "\t\t<response>1</response>\n";
		
		if (login("activeSearchStore") == "") login("activeSearchStore", ops("site_activeIndexStore"));	

		foreach ($login->s_vars as $var => $val) {
			$xml .= "\t\t<$var>$val</$var>\n";
		}

	} else {
	
		$xml .= "\t\t<response>0</response>\n";

	}
	
	$xml .= "\t</session>\n";
		
	$xml .= "\t<version>\n";
		
	$cnt = countUpperCaseArray("1") + countUpperCaseArray("4") + countUpperCaseArray("5");
	if ($cnt == 0) {
	
		$xml .= "\t\t<limited>1</limited>\n";
		
	}

	$xml .= "\t</version>\n";
		
	$xml .= "</document>\n";
	
	return $xml;
}

function prv_userLogout() {
	global $login;

	// TF

	$login->killSession();
	
	$xml = "<document>\n";
	
		$xml .= "\t<session>\n";
		$xml .= "\t\t<logout>1</logout>";
		$xml .= "\t</session>\n";

	$xml .= "</document>\n";
	
	return $xml;
}

function pub_heartbeatRequest() {
	global $login, $idsDB;

	// Intended to perform a session check, version check as well as return dynamic console preferences / settings

	$xml = "<document>\n";

	if (login("login") == true) {

		// Session Data

		$xml .= "\t<session>\n";

		$xml .= "\t\t<response>1</response>\n";

		if (login("activeSearchStore") == "") login("activeSearchStore", ops("site_activeIndexStore"));	

		foreach ($login->s_vars as $var => $val) {
			$xml .= "\t\t<$var>$val</$var>\n";
		}

		$xml .= "\t</session>\n";

		// Version Data

		$version = @file("../../version/version.txt");
		$currentMajor = trim($version[0]);
		$currentMinor = trim($version[1]);
		$currentName = trim($version[2]);
		$currentBuild = trim($version[3]);
	
		$version = @file("../../version/ver");
		$newMajor = trim($version[0]);
		$newMinor = trim($version[1]);
		$newName = trim($version[2]);
		$newBuild = trim($version[3]);

		$xml .= "\t<version>\n";
		
		$cnt = countUpperCaseArray("1") + countUpperCaseArray("4") + countUpperCaseArray("5");
		if ($cnt == 0) {
		
			$xml .= "\t\t<limited>1</limited>\n";
			
		}

		if ($newBuild > $currentBuild) {
		
			$xml .= "\t\t<newVersion>1</newVersion>\n";
			$xml .= "\t\t<message>New Version Available</message>\n";
			$xml .= "\t\t<details>v$newMajor.$newMinor ($newBuild) - $newName</details>\n";
		
		
		} else {
	
			$xml .= "\t\t<newVersion>0</newVersion>\n";
		
		}

		$xml .= "\t</version>\n";
		
		// Sensor Listing
		
		$userSensorArray = explode(",", login("sensors"));
	
		$xml .= "\t<sensorList>\n";
	
		$xml .= "\t\t<sensor>\n";
			$xml .= "\t\t\t<id>0</id>\n";
			$xml .= "\t\t\t<name>Available Sensors</name>\n";
		$xml .= "\t\t</sensor>\n";
	
		foreach ($userSensorArray as $sensor) {
	
			$xml .= "\t\t<sensor>\n";
	
			$q = $idsDB->query("SELECT id, name from idsSensor where id = '$sensor' and enabled = 1");
			while ($row = mysql_fetch_array($q, MYSQL_ASSOC)) {
			
				$xml .= "\t\t\t<id>" . $row['id'] . "</id>\n";
				$xml .= "\t\t\t<name>(" . $row['id'] . ") " . $row['name'] . "</name>\n";
			
			}
	
			$xml .= "\t\t</sensor>\n";
		
		}
	
		$xml .= "\t</sensorList>\n";
		
		// BPU Status messaging
		
		$t["A"] = 120;
		$t["B"] = 120;
		$t["C"] = 120;
		$t["D"] = 120;
		$t["E"] = 450;
		
		$noBPU = true;
		
		foreach (array("A", "B", "C", "D", "E") as $bpu) {
		
			if (file_exists("../../logs/bpu$bpu.sts")) {

				$noBPU = false;

				$tmp = file("../../logs/bpu$bpu.sts");
				
				$lineArray = explode(",", trim($tmp[0]));

				if ((time() - $t["$bpu"]) > $lineArray[1]) {
				
					$slowBPU[] = $bpu;
				
				}				
				
			}
			
		}
		
		if (count($slowBPU) > 0) {
			
//			insertUserMessage(login("id"), 2, "BPU: " . implode(", ", $slowBPU) . " slow or not responding");
		
		} else if ($noBPU == true) {

			insertUserMessage(login("id"), 2, "BPU's have not been started!");
		
		}
		
	} else {
	
		// No Session
	
		$xml .= "\t<session>\n";

		$xml .= "\t\t<response>0</response>\n";
	
		$xml .= "\t</session>\n";
	
	}

	$xml .= "</document>\n";
	
	return $xml;

}

?>

